state_manager = {}
states = {}

function state_manager.load()
   states[#states].load()
end
function state_manager.update(dt)
   if #states > 0 then
      states[#states].update(dt)
   else
      love.event.quit()
   end
end
function state_manager.draw()
   if #states > 0 then
      states[#states].draw()
   end
end

function state_manager.keypressed(key)
   states[#states].keypressed(key)
end
function state_manager.keyreleased(key)
   states[#states].keyreleased(key)
end

function state_manager.mousepressed(x, y, button)
   states[#states].mousepressed(x, y, button)
end
function state_manager.mousereleased(x, y, button)
   states[#states].mousereleased(x, y, button)
end

function state_manager.push(new_state)
   table.insert(states, new_state)
   love.graphics.setFont(states[#states].font)
   states[#states].load()
end
function state_manager.pop()
   states[#states].unload()
   table.remove(states, #states)
   
   if #states > 0 then
      love.graphics.setFont(states[#states].font)
   end
end