state_popup = {
   font = love.graphics.newFont(20),
}

function state_popup.load()
   state_popup.width     = 300
   state_popup.height    = 200
   
   state_popup.x         = (love.window.getWidth()  / 2) - (state_popup.width  / 2)
   state_popup.y         = 230
   
   state_popup.title.x   = (love.window.getWidth() / 2) - (state_popup.font:getWidth(state_popup.title.text) / 2)
   state_popup.title.y   = state_popup.y + 10
   state_popup.message.x = state_popup.x + 10
   state_popup.message.y = state_popup.y + 50
   
   state_popup.button = {
      text = 'OK',
      x = (love.window.getWidth() / 2) - (state_popup.font:getWidth('OK') / 2),
      y = 400,
      width = state_popup.font:getWidth('OK'),
      height = 20
   }
   if state_popup.title.text == 'EXIT' then
      state_popup.button.text = 'NO'
      state_popup.exit = {
         text = 'YES',
         x = (love.window.getWidth() / 2) - (state_popup.font:getWidth('YES') / 2),
         y = 375,
         width = state_popup.font:getWidth('YES'),
         height = 20
      }
   end
end
function state_popup.update(dt)
end
function state_popup.draw()
   if state_popup.title.text ~= 'PAUSE' then
      state_game.draw()
   end
   
   love.graphics.setColor(  0, 180, 200)
   love.graphics.rectangle('fill', state_popup.x, state_popup.y, state_popup.width, state_popup.height)
   love.graphics.setColor(255, 255, 255)
   for _, v in pairs({state_popup.title, state_popup.message}) do
      love.graphics.printf(v.text, v.x, v.y, state_popup.width - 10)
   end
   
   love.graphics.setColor(0, 100, 200)
   love.graphics.rectangle('fill', state_popup.button.x, state_popup.button.y, state_popup.button.width, state_popup.button.height)
   love.graphics.setColor(255, 255, 255)
   love.graphics.print(state_popup.button.text, state_popup.button.x, state_popup.button.y)
   
   if state_popup.title.text == 'EXIT' then
      love.graphics.setColor(0, 100, 200)
      love.graphics.rectangle('fill', state_popup.exit.x, state_popup.exit.y, state_popup.exit.width, state_popup.exit.height)
      love.graphics.setColor(255, 255, 255)
      love.graphics.print(state_popup.exit.text, state_popup.exit.x, state_popup.exit.y)
   end
end
function state_popup.unload()
   state_popup.width   = nil
   state_popup.height  = nil
   state_popup.x       = nil
   state_popup.y       = nil
   state_popup.title   = nil
   state_popup.message = nil
   state_popup.button  = nil
   state_popup.exit    = nil
end

function state_popup.keypressed(key)
end
function state_popup.keyreleased(key)
end

function state_popup.mousepressed(x, y, button)
   if button == 'l' then
      if x >= state_popup.button.x and x <= state_popup.button.x + state_popup.button.width and
         y >= state_popup.button.y and y <= state_popup.button.y + state_popup.button.height then
         state_popup.buttonPressed()
      elseif state_popup.exit then
         if x >= state_popup.exit.x and x <= state_popup.exit.x + state_popup.exit.width and
         y >= state_popup.exit.y and y <= state_popup.exit.y + state_popup.exit.height then
            state_manager.pop()
            state_manager.pop()
         end
      end
   end
end
function state_popup.mousereleased(x, y, button)
end

-----

function state_popup.buttonPressed()
   if state_popup.title.text == 'GAME OVER' then
      state_manager.pop()
      state_manager.pop()
   elseif state_popup.title.text == 'WORD WHACKED' then
      state_manager.pop()
      state_game.loadNewWord()
   elseif state_popup.title.text == 'PAUSE' or state_popup.title.text == 'EXIT' then
      state_manager.pop()
   end
end

function state_popup.display(title, message)
   state_popup.title = { text = title }
   state_popup.message = { text = message }
   state_manager.push(state_popup)
end