template = {}

function template.load(word)
   --Background
   template.background_image = love.graphics.newImage('images/background.png')

   --Words Tray
   template.words_tray = {
      width = words.max_width,
      height = words.max_height,
      y = 0
   }
   template.words_tray.x = (love.window.getWidth() / 2) - template.words_tray.width / 2 - (words.space * 2)
   
   --Guess Tray
   template.guess_tray = newTileSet('guess_tile', 0, 0)
   template.guess_tray.tile_width = template.guess_tray.image:getWidth()
   template.guess_tray.tile_height = template.guess_tray.image:getHeight()
   template.guess_tray.x = (love.window.getWidth() / 2) - ((template.guess_tray.tile_width * #word) / 2)
   template.guess_tray.y = 270
   template.guess_tray.length = #word
   template.guess_tray.batch:setBufferSize(#word)

   --Chars Tray
   template.chars_tray = {
      x = template.guess_tray.x - 15,
      y = 350,
      width = #word * template.guess_tray.image:getWidth() + 30,
      height = 85
   }
end
function template.update()
   --Guess Tray
   template.guess_tray.batch:bind()
   template.guess_tray.batch:clear()
   for i = 1, template.guess_tray.length do
      template.guess_tray.batch:add(template.guess_tray.x + (i - 1) * template.guess_tray.tile_width, template.guess_tray.y)
   end
   template.guess_tray.batch:unbind()
end
function template.draw()
   --Background
   love.graphics.draw(template.background_image)
   
   --Words Tray
   love.graphics.setColor(0, 0, 200)
   love.graphics.rectangle('fill', template.words_tray.x, template.words_tray.y, template.words_tray.width + (words.space * 3), template.words_tray.height)
   love.graphics.setColor(255, 255, 255)

   --Guess Tray
   template.guess_tray.draw()
   
   --Chars Tray
   love.graphics.setColor(0, 0, 100)
   love.graphics.rectangle('fill', template.chars_tray.x, template.chars_tray.y, template.chars_tray.width, template.chars_tray.height)
   love.graphics.setColor(255, 255, 255)
end
function template.unload()
   template.background_image = nil
   template.guess_tray       = nil
   template.chars_tray       = nil
end