function newAlphabetTileSet(image, tile_width, tile_height, max_chars)
   local tile_set = {
      image = love.graphics.newImage('images/' .. image .. '.png'),
      tile_width = tile_width,
      tile_height = tile_height,
      tile_types = {}
   }
   
   local set = 'ABCDEFGHIJKLM'
   for i = 1, #set do
      tile_set.tile_types[string.sub(set, i, i)] = love.graphics.newQuad(
         (i - 1) * tile_width,      0,
         tile_width,                tile_height,
         tile_set.image:getWidth(), tile_set.image:getHeight()
      )
   end
   
   set = 'NOPQRSTUVWXYZ '
   for i = 1, #set do
      tile_set.tile_types[string.sub(set, i, i)] = love.graphics.newQuad(
         (i - 1) * tile_width,      tile_height,
         tile_width,                tile_height,
         tile_set.image:getWidth(), tile_set.image:getHeight()
      )
   end
   
   tile_set.batch = love.graphics.newSpriteBatch(tile_set.image, max_chars)
   
   function tile_set.update(char_set)
      tile_set.batch:bind()
      tile_set.batch:clear()
      for _, v in pairs(char_set) do
         tile_set.batch:add(tile_set.tile_types[v.char], v.x, v.y)
      end
      tile_set.batch:unbind()
   end
   
   function tile_set.draw()
      love.graphics.draw(tile_set.batch)
   end
   
   return tile_set
end

function newTileSet(image, tile_width, tile_height)
   local tile_set = {
      image = love.graphics.newImage('images/' .. image .. '.png'),
      tile_width = tile_width,
      tile_height = tile_height,
      tile_types = {}
   }
   
   tile_set.batch = love.graphics.newSpriteBatch(tile_set.image, 1)
   
   function tile_set.draw()
      love.graphics.draw(tile_set.batch)
   end
   
   function tile_set.addTileType(id, x, y)
      tile_set.tile_types[id] = love.graphics.newQuad(x, y, tile_set.tile_width, tile_set.tile_height, tile_set.image:getWidth(), tile_set.image:getHeight())
   end
   
   return tile_set
end