words = {}

function words.load(word)
   words.list = {}
   words.image = love.graphics.newImage('images/words_tiles.png')
   words.tile_width  = 19
   words.tile_height = 20
   words.tile_quads = state_game.alphabetTileQuads(words.tile_width, words.tile_height, words.image:getWidth(), words.image:getHeight())
   
   local temp_height = 10
   words.max_width = 0
   words.y = 4
   words.space = 5
   words.longest = 0
   
   local temp_y = 0
   local temp_col_width = 0
   
   for a = 1, #dictionary do
      local used_chars = {}
      for b = 1, #dictionary[a] do
         table.insert(used_chars, string.sub(dictionary[a], b, b))
      end
      local c = 1
      while #used_chars > 0 and c <= #word do
         for i, v in pairs(used_chars) do
            if v == string.sub(word, c, c) then
               table.remove(used_chars, i)
            end
         end
         c = c + 1
      end
      
      if #used_chars == 0 then
         table.insert(words.list, {word = dictionary[a], x = words.max_width, y = words.y + (temp_y * words.tile_height), solved = false})
         temp_col_width = #dictionary[a] * words.tile_width
         words.longest  = #dictionary[a]
         temp_y = temp_y + 1

         if temp_y == temp_height then
            temp_y = 0
            words.max_width = words.max_width + temp_col_width + words.space
         end
      end
   end
   if temp_y > 0 then
      words.max_width = words.max_width + temp_col_width + words.space
   end
   
   words.x = (love.window.getWidth() / 2) - (words.max_width / 2)
   words.max_height = (temp_height * words.tile_height) + (words.space * 2)
end
function words.update()
   local solved_all = true
   for _, v in pairs(words.list) do
      if v.solved == false then
         solved_all = false
      end
   end
   
   if solved_all == true then
      state_popup.display('WORD WHACKED', 'You whacked all the words in my dictionary!')
   end
end
function words.draw()
   for i, v in pairs(words.list) do
      if timer.isEnded() and v.solved == false then
         love.graphics.setColor(0, 255,0)
         for fi = 1, #v.word do
            love.graphics.draw(words.image, words.tile_quads[string.sub(v.word, fi, fi)], words.x + v.x + ((fi - 1) * words.tile_width), v.y)
         end
         love.graphics.setColor(255, 255, 255)
      else
         if v.solved == true then
            for fi = 1, #v.word do
               love.graphics.draw(words.image, words.tile_quads[string.sub(v.word, fi, fi)], words.x + v.x + ((fi - 1) * words.tile_width), v.y)
            end
         else
            for fi = 1, #v.word do
               love.graphics.draw(words.image, words.tile_quads[' '], words.x + v.x + ((fi - 1) * words.tile_width), v.y)
            end
         end
      end
   end
end
function words.unload()
   words.list       = nil
   words.width      = nil
   words.image      = nil
   words.tile_quads = nil
   words.max_height = nil
   words.max_width  = nil
   words.y          = nil
   words.space      = nil
   words.x          = nil
   words.longest    = nil
end